﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="AddArticle.ascx.cs" Inherits="NewsViper.AdminControls.AddArticle" %>
<%@ Register TagPrefix="dnn" TagName="TextEditor" Src="~/controls/TextEditor.ascx"%>
<%@ Register TagPrefix="dnn" TagName="FilePickerUploader" Src="~/controls/filepickeruploader.ascx" %>


<h1>Add Article</h1>

<ng-form id="addRoot" ng-controller="ArticleAddCtrl" name="addRoot">

    <div class="row">
        <div class="col-sm-4"><label for="title">Title</label></div class="col-sm-4">
        <div class="col-sm-8">
            <asp:TextBox runat="server" ID="txtTitle" CssClass="txtTitle" Width="300px" ng-model="title" ng-blur="generateSeoName(title)" />
            <asp:RequiredFieldValidator ID="rfTitle" 
                runat="server" 
                ControlToValidate="txtTitle"
                Display="Dynamic"
                CssClass="NormalError"
                ResourceKey="rfTitle" />

        </div>
    </div>

    <div class="row">
        <div class="col-sm-4"><label for="summary">Summary</label></div>
        <div class="col-sm-8">
            <dnn:TextEditor ID="txtSummary" runat="server" Height="300" Width="500" />
            <asp:CustomValidator ID="rfSummary" 
                    runat="server" 
                    ControlToValidate="txtSummary"
                    ValidateEmptyText="true"
                    Display="Dynamic"
                    CssClass="NormalError"
                    ResourceKey="rfSummary" 
                    OnServerValidate="rfSummary_ServerValidate"/>
        </div>
    </div>

    <div class="row" style="margin-top:25px;">
        <div class="col-sm-4"><label for="body">Body</label></div>
        <div class="col-sm-8">
            <dnn:TextEditor ID="txtBody" runat="server" Height="500" Width="500" />
            <asp:CustomValidator ID="rfBody" 
                runat="server" 
                ControlToValidate="txtBody"
                ValidateEmptyText ="true"
                Display="Dynamic"
                CssClass="NormalError"
                ResourceKey="rfBody"
                OnServerValidate="rfBody_ServerValidate" />

        </div>
    </div>


    <div class="row">
        <div class="col-sm-4"><label for="fpMainImage">Main Image</label></div>
        <div class="col-sm-8"><dnn:FilePickerUploader ID="fpMainImage" runat="server" FileFilter="png,jpeg,jpg,gif" /></div>
    </div>

    <div class="row">
        <div class="col-sm-4"><label for="seoname">SEO Name</label></div>
        <div class="col-sm-8">
            <asp:TextBox runat="server" ID="txtSeoName" CssClass="txtSeoName" ng-model="seoname" />
            <asp:RequiredFieldValidator ID="rfSeoName" 
                    runat="server" 
                    ControlToValidate="txtSeoName"
                    Display="Dynamic"
                    CssClass="NormalError"
                    ResourceKey="rfSeoName" />
        </div>
    </div>

    <div class="row">
        <div class="col-sm-4"><label for="author">Author</label></div>
        <div class="col-sm-8"><asp:textbox runat="server" id="txtAuthor" /></div>
    </div>

    <div class="row">
        <div class="col-sm-4"><label for="isdraft">Is Draft</label></div>
        <div class="col-sm-8"><asp:CheckBox runat="server" ID="chkIsDraft" /></div>
    </div>

    <div class="row">
        <div class="col-sm-4"><label for="publishdate">Publish Date</label></div>
        <div class="col-sm-8"><asp:TextBox runat="server" id="txtPublishDate" ng-model="publishdate" jqdatepicker /></div>
    </div>

    <div class="row">
        <div class="col-sm-4"><label for="expirydate">Expiry Date</label></div>
        <div class="col-sm-8"><asp:TextBox runat="server" id="txtExpiryDate" ng-model="expirydate" jqdatepicker /></div>
    </div>

    <div class="row">
        <div class="col-sm-12">
            <asp:LinkButton runat="server" CssClass="btn btn-default" ID="btnSave" OnClick="btnSave_Click">Save</asp:LinkButton>
            <a href="#" id="hypCancel" runat="server" class="btn btn-default">Cancel</a>
        </div>
    </div>
    

</ng-form>


<script type="text/javascript">

    
    var AddApp = angular.module('AddApp', []);

    AddApp.controller('ArticleAddCtrl', function ArticleAddCtrl($scope, $http) {
        
        $scope.title = $('.txtTitle').val();
        $scope.seoname = $('.txtSeoName').val();


        $scope.generateSeoName = function(input){
            var data = {};
            data.portalId = <%= PortalId %>;
            data.title = input;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/GenerateArticleSeoName',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.seoname = data.d;
            });
        };

    });


    AddApp.directive('jqdatepicker', function () {
        return {
            restrict: 'A',
            require: 'ngModel',
            link: function ($scope, $element, $attrs, $ngModelCtrl) {
                
                $element.datepicker({
                    dateFormat: 'mm/dd/yy',
                    onSelect: function (value) {
                        $scope.$apply(function(){
                            $ngModelCtrl.$setViewValue(value);
                        });
                    }
                });
            }
        };
    });

    angular.element(document).ready(function () {
        angular.bootstrap(document.getElementById('addRoot'), ['AddApp']);
    });
</script>