﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="ArticleManager.ascx.cs" Inherits="NewsViper.AdminControls.ArticleManager" %>

<h1>Articles</h1>

<div id="managerRoot" ng-controller="ArticleManagerCtrl"  ng-cloak>
    <div ng-show="articles.length > 0">

        <table class="nvArticleManagerTable table table-striped">
            <thead>
                <tr>
                    <th>Title</th>
                    <th>Summary</th>
                    <th>Author</th>
                    <th style="min-width:100px;">Action</th>
                </tr>
            </thead>
            <tr ng-repeat="article in articles">
                <td>
                    <i ng-show="article.IsDraft" title="Draft" class="fa fa-pencil"></i>
                    <%--<i ng-show="article.IsPublished" title="Published" class="fa fa-eye"></i>--%>
                    <i ng-show="article.IsPending" title="Pending" class="fa fa-clock-o"></i>
                    <i ng-show="article.IsExpired" title="Expired" class="fa fa-clock-o" style="color:#ccc"></i>
                    <i ng-show="article.HasPendingComments" title="Pending Comments" class="fa fa-comments"></i>
                    {{article.Title}}
                </td>
                <td>{{article.SummaryNoHtml}}</td>
                <td>{{article.Author}}</td>
                <td>
                    <a ng-model="article.Id" class="btn btn-default btn-sm" editarticlelink><i class="fa fa-pencil"></i></a>
                    <a ng-click="deleteArticle(article.Id)" class="btn btn-danger btn-sm"><i class="fa fa-trash"></i></a>
                </td>
            </tr>
        </table>

        <div ng-show="totalItems > itemPerPage">
            <paging ng-model="totalItems" currentpage="pageIndex" createurl="generatePagingUrl(pageIndex)" itemsperpage="itemPerPage"></paging>
        </div>


    </div>

    <div ng-show="articles.length == 0">
        <h3>No Articles Defined</h3>
    </div>

    <a href="#" style="margin-top:15px;" class="btn btn-default" runat="server" id="hypAddArticle">Add New Article</a>
</div>


<script type="text/javascript">

    
    var ManagerApp = angular.module('ManagerApp', []);

    ManagerApp.controller('ArticleManagerCtrl', function ArticleManagerCtrl($scope, $http) {
        
        $scope.articles = [];
        $scope.pageIndex = 1;
        $scope.totalItems;
        $scope.itemPerPage = 20;

        $scope.loadArticles = function () {

            var data = {};
            data.portalId = <%= PortalId %>;
            data.pageSize = 25;
            data.pageIndex = $scope.pageIndex;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminListArticles',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.articles = data.d.Items;
                $scope.totalItems = data.d.TotalItems;
            });
        };

        $scope.deleteArticle = function(aId){
            if(confirm("Are you sure you want to delete this article?")){
                
                var data = {};
                data.articleId = aId;

                $http({
                    method: 'POST',
                    url: '<%= ServicePath %>/AdminDeleteArticle',
                    data: data,
                    headers: {
                        'Accept': 'application/json, text/javascript, */*; q=0.01',
                        'Content-Type': 'application/json; charset=utf-8'
                    }
                }).success(function (data) {
                    $scope.loadArticles();
                    toastr.success("Article deleted");
                }); 
            }
        };

        $scope.loadArticles();


    });


    ManagerApp.directive('editarticlelink', function () {
        return {
            restrict: 'A',
            require: 'ngModel',
            scope: {
                model: '=ngModel'
            },
            link: function ($scope, $element, $attrs, $ngModelCtrl) {
                
                var editUrl = '<%= DotNetNuke.Common.Globals.NavigateURL("", "PageId=EditArticle", "Id=-1")%>';

                $element.attr("href", editUrl.replace('-1', $scope.model));
            }
        };
    });

    angular.element(document).ready(function () {
        angular.bootstrap(document.getElementById('managerRoot'), ['ManagerApp']);
    });
</script>