﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="CategoryManager.ascx.cs" Inherits="NewsViper.AdminControls.CategoryManager" %>


<div id="categoryManager" ng-controller="CategoryManagerCtrl"  ng-cloak>
    <div ng-show="showAddEdit">
        <h2>Add/Edit Cateogory</h2>
        <div>
            <label>Category Name</label>
            <input type="text" ng-model="category.CategoryName" ng-blur="generateSeoName(category.CategoryName)" />
        </div>

        <div>
            <label>SEO Name</label>
            <input type="text" ng-model="category.SeoName" />
        </div>

        <div>
            <label>Description</label>
            <input type="text" ng-model="category.Description" />
        </div>

        <div>
            <label>Parent Category</label>
            <select ng-model="category.ParentCategory" ng-options="o.Value for o in parentCategories track by o.Key">
            </select>
        </div>

        <div style="margin-top:55px;">
            <a ng-click="saveCategory()" class="btn btn-default">Save</a>
            <a ng-click="showAddEdit = false; showCategoryList = true;" class="btn btn-default">Cancel</a>
        </div>

    </div>

    <div ng-show="showCategoryList">
        <h2>Existing Categories</h2>
    
        <ul class="nvCategoryList">
            <li ng-repeat="c in categories" class="nvCategoryDepth{{c.Depth}}">
                {{c.CategoryName}}
                <span class="badge">{{c.NumberOfArticles}}</span>
                
                <span class="pull-right">
                    <a ng-click="editCategoryAction(c.Id)" class="btn btn-default btn-sm"><i class="fa fa-pencil"></i></a>
                    <a ng-click="deleteCategory(c.Id)" class="btn btn-danger btn-sm"><i class="fa fa-trash"></i></a>
                </span>
                <div class="clearfix"></div>
            </li>

        </ul>

        <a ng-click="addCategory()" class="btn btn-default">Add Category</a>
    </div>

</div>


<script type="text/javascript">

    
    var ManagerApp = angular.module('ManagerApp', []);

    ManagerApp.controller('CategoryManagerCtrl', function CategoryManagerCtrl($scope, $http) {
        
        $scope.showCategoryList = true;
        $scope.showAddEdit = false;
        $scope.editCategory = -1;
        $scope.categories = [];

        $scope.parentCategories = [];

        $scope.category = {};

        $scope.loadCategories = function () {

            var data = {};
            data.portalId = <%= PortalId %>;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminListCategories',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.categories = data.d;
            });
        };

        $scope.loadParentCategories = function(){
            var data = {};
            data.portalId = <%= PortalId %>;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminListDropdownCategory',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.parentCategories = data.d;
                $scope.category.ParentCategory = $scope.parentCategories[0];
            });
        };

        $scope.loadParentCategories();


        $scope.editCategoryAction = function(cId){

            var data = {};
            data.portalId = <%= PortalId %>;
            data.categoryId = cId;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminGetCategory',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.editCategory = cId;
                $scope.category = data.d;
                $scope.showAddEdit = true;  
                $scope.showCategoryList = false;                
            });

            
        };

        $scope.deleteCategory = function(cId){
            if(confirm("Are you sure you want to delete this category?")){
                
                var data = {};
                data.portalId = <%= PortalId %>;
                data.categoryId = cId;

                $http({
                    method: 'POST',
                    url: '<%= ServicePath %>/AdminDeleteCategory',
                    data: data,
                    headers: {
                        'Accept': 'application/json, text/javascript, */*; q=0.01',
                        'Content-Type': 'application/json; charset=utf-8'
                    }
                }).success(function (data) {
                    $scope.loadCategories();
                    toastr.success("Category deleted");
                }); 
            }

        };

        $scope.addCategory = function(){
            $scope.editCategory = -1;
            $scope.category = {};
            $scope.showAddEdit = true;
            $scope.showCategoryList = false;
            $scope.category.ParentCategory = $scope.parentCategories[0];
        };

        $scope.saveCategory = function(){
            var data = {};
            data.portalId = <%= PortalId %>;
            data.editId = $scope.editCategory;
            data.name = $scope.category.CategoryName;
            data.seoName = $scope.category.SeoName;
            data.description = typeof($scope.category.Description) != 'undefined' ? $scope.category.Description : null;
            data.parentCategory = $scope.category.ParentCategory.Key;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminAddCategory',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.category = {};
                $scope.showAddEdit = false;
                $scope.showCategoryList = true;
                $scope.editCategory = -1;

                $scope.loadCategories();
                $scope.loadParentCategories();

                toastr.success("Category saved");
            });
        };

        $scope.generateSeoName = function(input){

            if(typeof(input) == 'undefined') return;

            var data = {};
            data.portalId = <%= PortalId %>;
            data.name = input;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/GenerateCategorySeoName',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.category.SeoName = data.d;
            });
        };
        
        $scope.loadCategories();
    });


    angular.element(document).ready(function () {
        angular.bootstrap(document.getElementById('categoryManager'), ['ManagerApp']);
    });
</script>