﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="Dashboard.ascx.cs" Inherits="NewsViper.AdminControls.Dashboard" %>


<div class="hidden" style="border:1px solid #ccc;margin:10px 0;padding:15px;">
    If you can see this then you need to click this button to enable the module to load Bootstrap
    <asp:button runat="server" Text="Load Bootstrap" ID="btnLoadBootstrap" OnClick="btnLoadBootstrap_Click" />
</div>

<h1>Dashboard</h1>


<h2 id="loadBootstrapWarning">If you can see this caption you need to enable the bootstrap option in the settings tab. This skin doens't appear to use bootstrap.</h2>
<h2 id="oldVersionBootstrap">This skin is using an old version of Bootstrap this module works better with version 3.3 or greater. Try forcin the module to load Bootstrap in Settings tab.</h2>

<div id="nvDashboard" ng-controller="dashboardCtrl" ng-cloak>

    <div class="row">
        <div class="col-md-4">
            <div class="nvDashboardWidget">
                <h4>Total Published Article: {{data.PublishedArticlesCount}}</h4>
            </div>
        </div>
        <div class="col-md-4">
            <div class="nvDashboardWidget">
                <h4>Total Pending Article: {{data.PendingArticlesCount}}</h4>
            </div>
        </div>
        <div class="col-md-4">
            <div class="nvDashboardWidget">
                <h4>Total Draft Article: {{data.DraftArticleCount}}</h4>
            </div>
        </div>
    </div>

    
    <div class="row">
        <div class="col-md-4">
            <div class="nvDashboardWidget">
               <h4>Top 5 Viewed Articles</h4>
                <table class="table table-bordered">
                    <tr ng-repeat="i in data.Top5ViewedArticles">
                        <td>{{$index + 1}}.</td>
                        <td><a href="{{articleLink(i.Id)}}">{{i.Title}}</a> <span class="badge">{{i.ViewCount}}</span></td>
                    </tr>
                </table>
            </div>
        </div>
        <div class="col-md-4">
            <div class="nvDashboardWidget">
                <h4>Top 5 Least Viewed Articles</h4>
                <table class="table table-bordered">
                    <tr ng-repeat="i in data.Top5LeastViewedArticles">
                        <td>{{$index + 1}}.</td>
                        <td><a href="{{articleLink(i.Id)}}">{{i.Title}}</a> <span class="badge">{{i.ViewCount}}</span></td>
                    </tr>
                </table>
            </div>
        </div>
        <div class="col-md-4">
            <div class="nvDashboardWidget">
                <h4>Top 5 Highest Rated Articles</h4>
                <table class="table table-bordered">
                    <tr ng-repeat="i in data.Top5RatedArticles">
                        <td>{{$index + 1}}.</td>
                        <td><a href="{{articleLink(i.Id)}}">{{i.Title}}</a> <span class="badge">{{i.AverageRating}}</span></td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
    
    <div class="row">
        <div class="col-md-4">
            <div class="nvDashboardWidget">
                <h4>Top 5 Authors By Article Count</h4>
                <table class="table table-bordered">
                    <tr ng-repeat="i in data.Top5AuthorsByArticleCount">
                        <td>{{$index + 1}}.</td>
                        <td>{{i.AuthorName}} <span class="badge">{{i.ArticleCount}}</span></td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
    
    
</div>


    <script type="text/javascript">


        var DashApp = angular.module('DashApp', []);

    DashApp.controller('dashboardCtrl', function commentCtrl($scope, $http) {
        $scope.data = {};

        $scope.loadDashboard = function () {
            var data = {};
            data.portalId = <%= PortalId%>;

            $http({
                method: 'POST',
                url: '<%= ServicePath%>/AdminDashboard',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.data = data.d;
            });
        };

        $scope.loadDashboard();

        $scope.articleLink = function(id){
            var navUrl = '<%= ArticleEditLink %>';
            return navUrl.replace('100', id);
        };

    });

    angular.element(document).ready(function () {
        angular.bootstrap(document.getElementById('nvDashboard'), ['DashApp']);

        //check to see if we have bootstrap 3 or greater
        //if we do hide the warning

        try{
            if(typeof($.fn.button) == "function"){
                $("#loadBootstrapWarning").hide();
            }

            if(parseInt($.fn.button.Constructor.VERSION[0]) >= 3){
                $("#oldVersionBootstrap").hide();
            }
        }
        catch(err) {}
    });

    </script>
