﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="EditArticle.ascx.cs" Inherits="NewsViper.AdminControls.EditArticle" %>
<%@ Register TagPrefix="dnn" TagName="TextEditor" Src="~/controls/TextEditor.ascx"%>
<%@ Register TagPrefix="dnn" TagName="FilePickerUploader" Src="~/controls/filepickeruploader.ascx" %>

<div role="tabpanel" id="editArticle" ng-controller="ArticleEditCtrl">


      <div class="dnnForm" id="tabs-newsViper">
        <ul class="dnnAdminTabNav">
            <li class="active"><a href="#general"><i class="fa fa-pencil"></i> General</a></li>
            <li><a href="#seo"><i class="fa fa-search"></i> SEO</a></li>
            <li><a href="#category"><i class="fa fa-sitemap"></i> Category</a></li>
            <li style="display:none;"><a href="#attribute"><i class="fa fa-list"></i> Attributes</a></li>
            <li><a href="#comments" ng-click="showComments()"><i class="fa fa-comment"></i> Comments</a></li>
            <li><a href="#history"  ng-click="showHistory()" data-toggle="tab"><i class="fa fa-history"></i> History</a></li>
        </ul>
          
        <div class="dnnClear" id="general">
        <div class="row">
            <div class="col-sm-4"><label for="title">Title</label></div>
            <div class="col-sm-8">
                <asp:TextBox runat="server" ID="txtTitle" Width="300px" CssClass="txtTitle" ng-model="title" ng-blur="generateSeoName(title)" />
                <asp:RequiredFieldValidator ID="rfTitle" 
                    runat="server" 
                    ControlToValidate="txtTitle"
                    Display="Dynamic"
                    CssClass="NormalError"
                    ResourceKey="rfTitle" />
            </div>
        </div>

        <div class="row">
            <div class="col-sm-4"><label for="summary">Summary</label></div>
            <div class="col-sm-8">
                <dnn:TextEditor ID="txtSummary" runat="server" Height="300" Width="500" />
                <asp:CustomValidator ID="rfSummary" 
                    runat="server" 
                    ControlToValidate="txtSummary"
                    ValidateEmptyText="true"
                    Display="Dynamic"
                    CssClass="NormalError"
                    ResourceKey="rfSummary" 
                    OnServerValidate="rfSummary_ServerValidate"/>
            </div>
        </div>

        <div class="row" style="margin-top:25px;">
            <div class="col-sm-4"><label for="body">Body</label></div>
            <div class="col-sm-8">
                <dnn:TextEditor ID="txtBody" runat="server" Height="500" Width="500" />
                <asp:CustomValidator ID="rfBody" 
                        runat="server" 
                        ControlToValidate="txtBody"
                        ValidateEmptyText ="true"
                        Display="Dynamic"
                        CssClass="NormalError"
                        ResourceKey="rfBody"
                        OnServerValidate="rfBody_ServerValidate" />
            </div>
        </div>

        <div class="row">
            <div class="col-sm-4"><label for="fpMainImage">Main Image</label></div>
            <div class="col-sm-8"><dnn:FilePickerUploader ID="fpMainImage" runat="server" FileFilter="png,jpeg,jpg,gif" /></div>
        </div>

        <div class="row">
            <div class="col-sm-4"><label for="author">Author</label></div>
            <div class="col-sm-8">
                
                <asp:HiddenField runat="server" ID="hfAuthorId" Value="{{authorId}}"/>

                <div class="input-group">
    	            <input type="text" name="authorName" class="" ng-model="authorinternal" ng-change="changeAuthorText()">
    	            <div style="float:right;">
    		            <button type="button" class="btn btn-default btn-xs dropdown-toggle" data-toggle="dropdown"><span class="caret"></span></button>
    		            <ul id="author-dropdown-menu" class="dropdown-menu dropdown-menu-right" role="menu">
    			            <li ng-repeat="author in authors" class="input-lg">
                                <a ng-click="changeAuthor(author)">{{author.Name}}</a>
    			            </li>
    		            </ul>
    	            </div>
                </div>

              

            </div>
        </div>

        <div class="row">
            <div class="col-sm-4"><label for="isdraft">Is Draft</label></div>
            <div class="col-sm-8"><asp:CheckBox runat="server" ID="chkIsDraft" CssClass="normalCheckBox" /></div>
        </div>

        <div class="row">
            <div class="col-sm-4"><label for="publishdate">Publish Date</label></div>
            <div class="col-sm-8"><asp:TextBox runat="server" id="txtPublishDate" jqdatepicker /></div>
        </div>

        <div class="row">
            <div class="col-sm-4"><label for="expirydate">Expiry Date</label></div>
            <div class="col-sm-8"><asp:textbox runat="server" type="text" id="txtExpiryDate" jqdatepicker /></div>
        </div>
    </div>

        <div class="dnnClear" id="seo">
            <div class="row">
                <div class="col-sm-4"><label for="seoname">SEO Name</label></div>
                <div class="col-sm-8">
                    <asp:TextBox runat="server" ID="txtSeoName" CssClass="txtSeoName" ng-model="seoname" />
                    <asp:RequiredFieldValidator ID="rfSeoName" 
                        runat="server" 
                        ControlToValidate="txtSeoName"
                        Display="Dynamic"
                        CssClass="NormalError"
                        ResourceKey="rfSeoName" />
                </div>
            </div>
            <div class="row">
                <div class="col-sm-4"><label for="seoname">SEO Keywords</label></div>
                <div class="col-sm-8"><asp:TextBox runat="server" ID="txtSeoKeywords" Rows="5" Columns="30" TextMode="MultiLine"/></div>
            </div>

            <div class="row">
                <div class="col-sm-4"><label for="seoname">SEO Description</label></div>
                <div class="col-sm-8"><asp:TextBox runat="server" ID="txtSeoDescription" Rows="5" Columns="30" TextMode="MultiLine"/></div>
            </div>
        </div>

        <div class="dnnClear" id="category">

            <div class="row">
                <div class="col-sm-11 col-sm-offset-1">
                    <ul class="nvCategoryArticleAssignmentList">
                        <li ng-repeat="c in categories" class="nvCategoryDepth{{c.Depth}}">
                            <input type="checkbox" class="normalCheckBox"
                                                    ng-checked="c.IsSelected" 
                                                    ng-model="c.IsSelected"
                                                    ng-change="saveCategoryAssignment(c.CategoryId, c.IsSelected)"/><span> {{c.Name}} {{c.ParentCategory}}</span>
                        </li>

                    </ul>
                </div>
            </div>

        </div>

        <div class="dnnClear" id="attribute">...</div>

        <div class="dnnClear" id="comments">
            <div ng-hide="comments.length > 0" style="margin:10px;">No comments</div>

            <div class="row">
                <div class="col-sm-11 col-sm-offset-1">
                    <table style="width:100%" class="nvArticleCommentsTable table table-striped" ng-show="comments.length > 0">
                        <thead>
                            <tr>
                                <th>Author</th>
                                <th>Created</th>
                                <th>Approved</th>
                                <th></th>
                            </tr>
                        </thead>

                        <tr ng-repeat="c in comments">
                            <td><span ng-bind-html="c.Author | commentAuthor"></span></td>
                            <td>{{c.CreatedDate | aspNetDateTime}}</td>
                            <td>{{c.IsApproved}}</td>
                            <td>
                                <a ng-click="editCommentAction(c.Id)" class="btn btn-default btn-sm"><i class="fa fa-pencil"></i></a>
                                <a ng-click="deleteComment(c.Id)" class="btn btn-danger btn-sm"><i class="fa fa-trash" style="color:#fff;"></i></a>
                            </td>
                        </tr>

                    </table>


                    <div ng-show="showCommentEdit">

                        <div>
                            <label for="commentAuthor">Author</label>
                            <input type="text" id="commentAuthor" ng-model="editComment.Author" />
                        </div>

                        <div>
                            <label for="commentTitle">Title</label>
                            <input type="text" id="commentTitle" ng-model="editComment.Title" />
                        </div>

                        <div>
                            <label for="commentBody">Comment</label>
                            <textarea id="commentBody" ng-model="editComment.Body"></textarea>
                        </div>

                        <div>
                            <label for="commentIsApproved">Is Approved</label>
                            <input type="checkbox" class="normalCheckBox" id="commentIsApproved" ng-model="editComment.IsApproved" />
                        </div>

                        <div style="margin-bottom:10px;">
                            <a class="btn btn-xs btn-default" ng-click="saveComment(editComment)">Save</a>
                            <a class="btn btn-xs btn-default" ng-click="deleteComment(editComment.Id)">Delete</a>
                            <a class="btn btn-xs btn-default" ng-click="cancelComment()">Cancel</a>
                        </div>

                    </div>

                </div>
            </div>

        </div>

        <div class="dnnClear" id="history">

            <div class="row">
                <div class="col-sm-11 col-sm-offset-1">
                    <ul ng-hide="diff.OldText" class="articleHistoryList">
                        <p ng-hide="articleHistory.length > 0">
                            No modifications
                        </p>
                        <li ng-repeat="h in articleHistory" ng-show="articleHistory.length > 0">
                            <span style="width:220px;display:inline-block;">
                                Version {{articleHistory.length - $index}} 
                                <span>{{h.ModifiedDate | aspNetDateTime}}</span>
                            </span>

                            <div class="btn-group articleActionButton">
                              <a type="button" class="btn btn-xs btn-default dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
                                Show Changes <span class="caret"></span>
                              </a>
                              <ul class="dropdown-menu" role="menu">
                                <li>
                                    <a ng-click="compareArticleHistory(h.ArticleId, h.Id, -1)">With Current</a>
                                </li>
                                <li ng-show="$index < articleHistory.length - 1">
                                    <a ng-click="compareArticleHistory(h.ArticleId, h.Id, articleHistory[$index + 1].Id)">With Version Before This Change</a>
                                </li>
                              </ul>
                            </div>
                                
                            <a class="btn btn-default btn-xs" style="margin-left:5px;" ng-click="rollBackArticle(h.ArticleId)">Rollback</a>

                        </li>
                    </ul>
                </div>
            </div>


            <div ng-show="diff.OldText" class="row">
                <div class="col-md-6">
                    <div class="diffPane">
                        <table cellpadding="0" cellspacing="0" class="diffTable">

                            <tr ng-repeat="line in diff.OldText.Lines">
                                <td class="lineNumber">
                                    {{ line.Position ? line.Position : "&nbsp;" }}
                                </td>
                                <td class="line Diff{{ line.Type }}Line">
                                    <span class="lineText">

                                        <span ng-show="line.Type != 4">{{line.Text}}</span>

                                        <span ng-show="line.Type == 4">
                                            <span ng-repeat="sp in line.SubPieces" ng-show="sp.Type != 3" class="Diff{{sp.Type}}Character">{{sp.Text}}</span>
                                        </span>

                                    </span>
                                </td>
                            </tr>
                        </table>
                    </div>
                </div>


                <div class="col-md-6">
                    <div class="diffPane">
                        <table cellpadding="0" cellspacing="0" class="diffTable">

                            <tr ng-repeat="line in diff.NewText.Lines">
                                <td class="lineNumber">
                                    {{ line.Position ? line.Position : "&nbsp;" }}
                                </td>
                                <td class="line Diff{{ line.Type }}Line">
                                    <span class="lineText">

                                        <span ng-show="line.Type != 4">{{line.Text}}</span>

                                        <span ng-show="line.Type == 4">
                                            <span ng-repeat="sp in line.SubPieces" ng-show="sp.Type != 3" class="Diff{{sp.Type}}Character">{{sp.Text}}</span>
                                        </span>

                                    </span>
                                </td>
                            </tr>
                        </table>
                    </div>
                </div>

                <div class="row">
                    <div class="col-sm-12">
                        <a ng-click="diff = {}">Return to History List</a>
                    </div>
                </div>

            </div>


        </div>

      </div>


  <div style="margin-top:55px;">
      <asp:LinkButton runat="server" CssClass="btn btn-default" id="btnSave" OnClick="btnSave_Click">Save</asp:LinkButton>
      <asp:LinkButton runat="server" CssClass="btn btn-default" ID="btnDelete" OnClick="btnDelete_Click">Delete</asp:LinkButton>
      <asp:HyperLink runat="server" CssClass="btn btn-default" ID="hypCancel">Cancel</asp:HyperLink>

  </div>

</div>



<script type="text/javascript">

    
    var EditApp = angular.module('EditApp', []);

    EditApp.controller('ArticleEditCtrl', function ArticleEditCtrl($scope, $http) {
        
        $scope.title = $('.txtTitle').val();
        $scope.seoname = $('.txtSeoName').val();
        $scope.categories = [];

        $scope.hasLoadedArticleHistory = false;
        $scope.articleHistory = [];

        $scope.authors = <%= Authors %>;
        $scope.authorId = <%= AuthorId %>;
        $scope.authorinternal = "<%= AuthorName %>";

        $scope.hasLoadedComments = false;
        $scope.comments = [];
        $scope.editComment = {};
        $scope.showCommentList = false;
        $scope.showCommentEdit = false;

        $scope.diff = {};


        $scope.showComments = function(){
            if(!$scope.hasLoadedComments){
                $scope.loadComments();
            }
        };


        $scope.changeAuthorText = function(){
            $scope.authorId = -1;
        };

        $scope.changeAuthor = function(author){
            $scope.authorinternal = author.Name;
            $scope.authorId = author.Id;
        };

        $scope.loadComments = function(){
            var data = {};
            data.articleId = <%= Request.QueryString["Id"] %>;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminArticleComments',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.comments = data.d;
                $scope.hasLoadedComments = true;
                $scope.showCommentList = true;
                $scope.showCommentEdit = false;
            });
        };

        $scope.editCommentAction = function(id){
            var data = {};
            data.commentId = id;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/LoadComment',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.editComment = data.d;
                $scope.showCommentList = false;
                $scope.showCommentEdit = true;
            });
        };


        $scope.saveComment = function(comment){
            
            comment.ModifiedDate = null;
            comment.CreatedDate = new Date();

            var data = {};
            data.comment = comment;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminUpdateComment',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.loadComments();
                toastr.success("Comment saved");
            });
        };

        $scope.cancelComment = function(){
            $scope.editComment = {};
            $scope.showCommentList = true;
            $scope.showCommentEdit = false;
        };

        $scope.deleteComment = function(id){
            if(confirm('Are you sure want to delete this comment?')){
                var data = {};
                data.commentId = id;

                $http({
                    method: 'POST',
                    url: '<%= ServicePath %>/AdminDeleteComment',
                    data: data,
                    headers: {
                        'Accept': 'application/json, text/javascript, */*; q=0.01',
                        'Content-Type': 'application/json; charset=utf-8'
                    }
                }).success(function (data) {
                    $scope.loadComments();
                    toastr.success("Comment deleted");
                });
            }
        };

        $scope.showHistory = function(){
            if(!$scope.hasLoadedArticleHistory)
            {
                $scope.loadArticleHistory();
            }
        };

        $scope.compareArticleHistory = function(articleId,
                                                 currentArticleVersion, 
                                                 compareAgainstVersion){

            var data = {};
            data.articleId = articleId;
            data.currentArticleVersion = currentArticleVersion;
            data.comparisonArticleVersion = compareAgainstVersion;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminCompareArticles',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                console.log(data.d);
                $scope.diff = data.d;
            });
        };

        $scope.rollBackArticle = function(id){
            if(confirm('Are you sure want to revert to this version?')){
                var data = {};
                data.articleHistoryId = id;

                $http({
                    method: 'POST',
                    url: '<%= ServicePath %>/AdminArticleHistoryRollback',
                    data: data,
                    headers: {
                        'Accept': 'application/json, text/javascript, */*; q=0.01',
                        'Content-Type': 'application/json; charset=utf-8'
                    }
                }).success(function (data) {
                    location.reload();
                });
            }
        };

        $scope.loadArticleHistory = function(){
            var data = {};
            data.articleId = <%= Request.QueryString["Id"] %>;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminArticleHistory',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.articleHistory = data.d;
                $scope.hasLoadedArticleHistory = true;
            });
        };


        $scope.generateSeoName = function(input){
            var data = {};
            data.portalId = <%= PortalId %>;
            data.title = input;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/GenerateArticleSeoName',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.seoname = data.d;
            });
        };

        $scope.saveCategoryAssignment = function(id, isSelected){
            var data = {};
            data.portalId = <%= PortalId %>;
            data.articleId = <%= Request.QueryString["Id"] %>;
            data.categoryId = id;
            data.selected = isSelected;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminSaveArticleCategories',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                if(isSelected){
                    toastr.success("Article assigned to category");
                }else{
                    toastr.success("Article unassigned from category");
                }
            });
        };


        $scope.loadCategories = function(){
            var data = {};
            data.portalId = <%= PortalId %>;
            data.articleId = <%= Request.QueryString["Id"] %>;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminLoadArticleCategories',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.categories = data.d;
            });
        };

        $scope.loadCategories();

    });


    EditApp.directive('jqdatepicker', function () {
        return {
            restrict: 'A',
            //require: 'ngModel',
            link: function ($scope, $element, $attrs, $ngModelCtrl) {
                
                $element.datepicker({
                    dateFormat: 'mm/dd/yy',
                    onSelect: function (value) {
                    //    $scope.$apply(function(){
                    //        $ngModelCtrl.$setViewValue(value);
                    //    });
                    }
                });
            }
        };
    });


    EditApp.filter('aspNetDateTime', function () {
        return function (item) {
            var pattern = /Date\(([^)]+)\)/;
            var results = pattern.exec(item);
            var dt = new Date(parseFloat(results[1]));
            return (dt.getMonth() + 1) + "/" + dt.getDate() + "/" + dt.getFullYear() + " " + dt.getHours() + ":" + (dt.getMinutes()<10?'0':'') + dt.getMinutes()
        };
    });

    EditApp.filter('commentAuthor', function($sce){
        return function(item){
            if(item == null || item.length == 0){
                return  $sce.trustAsHtml("<em>Annoymous</em>");
            }else{
                return $sce.trustAsHtml(item);
            }
        };
    });

    angular.element(document).ready(function () {
        angular.bootstrap(document.getElementById('editArticle'), ['EditApp']);
        $('#tabs-newsViper').dnnTabs({ selected : 0});
    });
</script>