﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="License.ascx.cs" Inherits="NewsViper.AdminControls.License" %>
<%@ Register TagPrefix="dnn" Namespace="DotNetNuke.Web.Client.ClientResourceManagement" Assembly="DotNetNuke.Web.Client" %>

<dnn:DnnJsInclude runat="server" FilePath="~/DesktopModules/NewsViper/Templates/Js/angular-file-upload-shim.min.js" Priority="110"/>
<dnn:DnnJsInclude runat="server" FilePath="~/DesktopModules/NewsViper/Templates/Js/angular-file-upload.min.js" Priority="110"/>

<h1>License Manager</h1>

<div id="licenseRoot" ng-controller="LicenseCtrl" ng-cloak>

    <div ng-show="license.Status == 'trial' || license.Status == 'developer'">
        <div class="alert alert-info" role="alert">
            <h4>This module is currently in trial mode and you have {{license.RemainingTrial}} days left of the trial.</h4>
        </div>
    </div>

    <div ng-show="license.Status == 'unlicensed'">
        <div class="alert alert-danger" role="alert">
            <h4>This module is unlicensed, the trial has expired. Please purchase a license to unlock the module.</h4>
        </div>
    </div>

    <div ng-show="license.Status == 'licensed'">
        <div class="alert alert-success" role="alert">
            <h4><i class="fa fa-ticket"></i> Module is Licensed</h4>
        </div>
    </div>

    <h4 style="margin-top:30px;border-bottom:1px solid #ccc;padding-bottom:5px;">Upload License</h4>
    <input type="file" ng-model="licenseFile" ng-file-select/>
    <a ng-click="uploadLicense(licenseFile)" class="btn btn-default" style="margin-top:10px;">Upload License</a>

</div>


<script type="text/javascript">

    var LicenseApp = angular.module('LicenseApp', ['ngFileUpload']);

    LicenseApp.controller('LicenseCtrl', function LicenseCtrl($scope, $http, $upload, $timeout) {

        $scope.license = {};

        $scope.checkLicense = function(){
            var data = {};
            data.portalId = <%= PortalId%>;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/LicenseStatus',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.license = data.d;
            });
        };

        $scope.checkLicense();

        $scope.uploadLicense = function(licenseFile){
            if (licenseFile && licenseFile.length) {
                for (var i = 0; i < licenseFile.length; i++) {
                    var file = licenseFile[i];
                    $upload.upload({
                        url: '<%= DotNetNuke.Common.Globals.ResolveUrl("/DesktopModules/NewsViper/Licensing/LicenseUpload.ashx")  %>',
                        fields: {'portalId': <%= PortalId %>},
                        file: file
                    }).progress(function (evt) {
                        var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                    }).success(function (data, status, headers, config) {
                        $timeout($scope.checkLicense(), 2000);
                    });
                }
            }
        };
        

    });

    angular.element(document).ready(function () {
        angular.bootstrap(document.getElementById('licenseRoot'), ['LicenseApp']);
    });

</script>