﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="Settings.ascx.cs" Inherits="NewsViper.AdminControls.Settings" %>
<h1>Settings</h1>

<div id="settingsRoot" ng-controller="SettingManagerCtrl"  ng-cloak>
    <ng-form name="settingsForm">
        <div ng-repeat="setting in settings" class="nvGlobalSettingsRow">
            <label>{{setting.DisplayName}}</label>

            <input type="text" ng-model="setting.Value" ng-hide="setting.Control == 1" style="width:350px;" />
            <input type="checkbox" class="normalCheckBox" ng-model="setting.Value" ng-true-value="true" ng-false-value="false"
                     ng-checked="setting.Value.toLowerCase() == 'true'" ng-show="setting.Control == 1" />
        </div>

        <a class="btn btn-default" disabled="disabled" ng-hide="settingsForm.$dirty" >Save</a>
        <a class="btn btn-default" ng-show="settingsForm.$dirty" ng-click="saveSettings()">Save</a>

    </ng-form>
</div>


<script type="text/javascript">

    
    var ManagerApp = angular.module('ManagerApp', []);

    ManagerApp.controller('SettingManagerCtrl', function SettingManagerCtrl($scope, $http) {
        $scope.settings = [];


        $scope.loadSettings = function () {
            var data = {};
            data.portalId = <%=PortalId%>;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminLoadSettings',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                $scope.settings = data.d;
            });
            
        };

        $scope.loadSettings();


        $scope.saveSettings = function () {
            var data = {};
            data.portalId = <%=PortalId%>;
            data.settings = $scope.settings;

            $http({
                method: 'POST',
                url: '<%= ServicePath %>/AdminSaveSettings',
                data: data,
                headers: {
                    'Accept': 'application/json, text/javascript, */*; q=0.01',
                    'Content-Type': 'application/json; charset=utf-8'
                }
            }).success(function (data) {
                toastr.success("Settings Saved");
            });
            
        };

    });


    angular.element(document).ready(function () {
        angular.bootstrap(document.getElementById('settingsRoot'), ['ManagerApp']);
    });

</script>