﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="ViewSettings.ascx.cs" Inherits="NewsViper.ViewSettings" %>
<%@ Register TagPrefix="dnn" TagName="Label" Src="~/controls/LabelControl.ascx" %>

<div class="epmNoBootstrap container">
    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblViewMode" runat="server" controlname="ddlViewMode" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:DropDownList runat="server" ID="ddlViewMode"></asp:DropDownList>
        </div>
    </div>
    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblTheme" runat="server" controlname="ddlTheme" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:DropDownList runat="server" ID="ddlTheme"></asp:DropDownList>
        </div>
    </div>
    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblEnablePaging" runat="server" controlname="chkEnablePaging" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:CheckBox runat="server" ID="chkEnablePaging"></asp:CheckBox>
        </div>
    </div>

    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblPageSize" runat="server" controlname="txtPageSize" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:TextBox runat="server" Columns="5" ID="txtPageSize"></asp:TextBox>
            <asp:RequiredFieldValidator ForeColor="Red" runat="server" ID="RequiredFieldValidator5" ErrorMessage="Required" Display="Dynamic" ControlToValidate="txtPageSize"></asp:RequiredFieldValidator>
        </div>
    </div>

    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblEnableFilter" runat="server" controlname="chkEnableFilter" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:CheckBox runat="server" ID="chkEnableFilter"></asp:CheckBox>
        </div>
    </div>

    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblFilterCategories" runat="server" controlname="chkLstCategories" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:Panel ID="pnlCategoryOptions" CssClass="nvAdminCategoryTree" runat="server"></asp:Panel>
            <asp:CheckBoxList runat="server" ID="CheckBoxList1" />
        </div>
    </div>

    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblFilterAuthors" runat="server" controlname="chkLstAuthors" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:CheckBoxList runat="server" ID="chkLstAuthors" />
        </div>
    </div>


    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblSorting" runat="server" controlname="ddlSortColumn" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:DropDownList runat="server" ID="ddlSortColumn">
                <asp:ListItem Text="Published date" Value="0" />
                <asp:ListItem Text="Expiry date" Value="1" />
                <asp:ListItem Text="Modified date" Value="2" />
                <asp:ListItem Text="View count" Value="3" />                        
                <asp:ListItem Text="Rating" Value="4" />
                <asp:ListItem Text="Title" Value="5" />
            </asp:DropDownList>

            <asp:DropDownList runat="server" ID="ddlSortDirection">
                <asp:ListItem Text="Ascending" Value="-1" />
                <asp:ListItem Text="Descending" Value="1" />
            </asp:DropDownList>
        </div>
    </div>
    
    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblEnableRatings" runat="server" controlname="chkEnableRatings" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:CheckBox runat="server" ID="chkEnableRatings"></asp:CheckBox>
        </div>
    </div>

    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblEnableComments" runat="server" controlname="chkEnableComments" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:CheckBox runat="server" ID="chkEnableComments"></asp:CheckBox>
        </div>
    </div>

    <div class="row">
        <div class="col-sm-4">
            <dnn:Label id="lblNewsDetailsPage" runat="server" controlname="ddlNewsDetailsPage" suffix=":"></dnn:Label>
        </div>
        <div class="col-sm-8">
            <asp:DropDownList runat="server" ID="ddlNewsDetailsPage"></asp:DropDownList>
        </div>
    </div>
</div>